package net.t2code.autoresponse.Spigot.system;

import net.t2code.autoresponse.Spigot.Main;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;

public class BCommand_Sender_Reciver {

    public static void sendToBungee(CommandSender sender, String information, BungeeSend type) {
        ByteArrayOutputStream stream = new ByteArrayOutputStream();
        DataOutputStream output = new DataOutputStream(stream);

        try {
            switch (type) {
                case BUNGEECOMMAND:
                    output.writeUTF("ConC");
                    break;
                case COMMAND:
                    if (sender instanceof Player) {
                        output.writeUTF(sender.getName());
                    } else {
                        output.writeUTF("ConC");
                    }
                    break;
                case ALLPLAYERMSG:
                    output.writeUTF("ALLPMSG");
                    break;
            }
            output.writeUTF(information);
        } catch (IOException e) {
            e.printStackTrace();
        }

        if (sender instanceof Player) {
            Player player = (Player) sender;
            player.sendPluginMessage(Main.getPlugin(), "t2car:bungee", stream.toByteArray());
        } else {
            for (Player player : Bukkit.getOnlinePlayers()) {
                player.sendPluginMessage(Main.getPlugin(), "t2car:bungee", stream.toByteArray());
                return;
            }
        }
    }

}
