package net.t2code.autoresponse.Spigot.system;

import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Spigot.objects.ResponsesObject;
import net.t2code.lib.Spigot.Lib.register.Register;
import org.bukkit.permissions.PermissionDefault;

public class Permissions {

    public static final String key = "t2code.autoresponse.";
    public static final String info = key + "command.info";
    public static final String updatemsg = key + "updatemsg";
    public static final String admin = key + "admin";
    public static final PermissionDefault op = PermissionDefault.OP;
    public static final PermissionDefault notOp = PermissionDefault.NOT_OP;

    protected static void register() {
        Register.permission(info, op, Main.getPlugin());
        Register.permission(updatemsg, op, Main.getPlugin());
        Register.permission(admin, op, info, true, Main.getPlugin());
        Register.permission(admin, op, updatemsg, true, Main.getPlugin());
        for (ResponsesObject response : Main.allResponses) {
            Register.permission(response.permission, op, Main.getPlugin());
        }
    }
}
