package net.t2code.autoresponse.Spigot.system;

import net.t2code.autoresponse.Spigot.Main;
import net.t2code.autoresponse.Util;
import net.t2code.autoresponse.Spigot.cmdManagement.CmdExecuter;
import net.t2code.autoresponse.Spigot.config.config.CreateConfig;
import net.t2code.autoresponse.Spigot.config.config.SelectConfig;
import net.t2code.autoresponse.Spigot.config.languages.CreateMessages;
import net.t2code.autoresponse.Spigot.config.languages.SelectMessages;
import net.t2code.autoresponse.Spigot.config.response.CreateExampleResponse;
import net.t2code.autoresponse.Spigot.config.response.SelectResponses;
import net.t2code.autoresponse.Spigot.event.ResponseListener;
import net.t2code.lib.Spigot.Lib.messages.T2CodeTemplate;
import net.t2code.lib.Spigot.Lib.update.UpdateAPI;
import org.bukkit.Bukkit;
import org.bukkit.plugin.Plugin;

import java.util.List;

public class Load {
    static Main plugin = Main.getPlugin();
    public static void onLoad(String prefix, List<String> autor, String version, String spigot, int spigotID, String discord, int bstatsID) {
        Long long_ = T2CodeTemplate.onLoadHeader(prefix, autor, version, spigot, discord);
        plugin.getCommand("t2code-autoresponse").setExecutor( new CmdExecuter());

        loadReload();
        UpdateAPI.onUpdateCheck(plugin, prefix, spigot, spigotID, discord);
        Bukkit.getServer().getPluginManager().registerEvents(new JoinEvent(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new ResponseListener(), plugin);

        T2CodeTemplate.onLoadFooter(prefix, long_,version);
        Metrics.Bstats(plugin, bstatsID);
        if (SelectConfig.bungee) {
            plugin.getServer().getMessenger().registerOutgoingPluginChannel(plugin, "BungeeCord");
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, "t2car:bungee");
        }
        Permissions.register();
    }

    public static void loadReload() {
        CreateConfig.configCreate();
        CreateMessages.langCreate();
        CreateExampleResponse.configCreate();

        SelectConfig.onSelect();
        SelectMessages.onSelect(Util.getPrefix());
        SelectResponses.onSelect();
    }
}
